<template>
  <div class="container-fluid">
    <div class="row">
      <div class="col-sm-12">
        <div class="card rounded shadow web-only">
          <!-- show user admins -->
          <span v-if="creating === false">
            <div class="col-sm-12 mt-3  d-flex justify-content-between">
              <div class="form-search d-flex align-items-center">
                <i class="fa fa-search" @click="init(0, true)"></i>
                <input
                  class="form-control pr-4"
                  @keyup.enter="init(0, true)"
                  type="search"
                  placeholder="Rechercher (Nom)"
                  v-model="searchtext"
                />
              </div>
              <div class="form-group mt-4">
                <input type="submit"
                  class="btn btn-light btn-block" value="Ajouter" @click="creating = true;"/>
              </div>
            </div>
            <div class="p-5" v-if="isLoading">
              <fulfilling-bouncing-circle-spinner class="mx-auto"
                :animation-duration="2000" :size="60" :color="'#005C96'" />
            </div>
            <div v-else>
              <div class="card-body">
                <div class="table-responsive">
                  <table class="table rounded">
                    <thead>
                      <th></th>
                      <th>Nom & Prénom(s)</th>
                      <th>Profession</th>
                      <th>Email</th>
                    </thead>
                    <tbody>
                      <tr v-for="(admin, i) in admins" :key="i">
                        <td>
                          <img v-if="admin.pictures[0]" :src="admin.pictures[0]"  width="60" height="60" class="img-profile rounded-circle" />
                          <img v-else :src="'https://yelumi.s3.us-east-2.amazonaws.com/koala.png'" width="60" height="60" class="img-profile rounded-circle"/>
                        </td>
                        <td> {{ admin.firstname }} {{ admin.lastname }} </td>
                        <td> {{ admin.profession }} </td>
                        <td> {{ admin.email }} </td>
                        <!--  <td> {{ admin.active ? 'activé' : 'désactivé' }} </td>
                        <td v-if=" admin.active">
                          <button type="button" class="btn btn-success btn-sm"
                            @click="changeStatut(admin._id,admin.active)">
                            <i class="fa fa-redo"></i>
                            <i class="las la-sync"></i>
                          </button>
                        </td>
                        <td v-else>
                          <button type="button" class="btn btn-danger btn-sm"
                            @click="changeStatut(admin._id,admin.active)">
                            <i class="fa fa-redo"></i>
                            <i class="las la-sync"></i>
                          </button>
                        </td> -->
                      </tr>
                    </tbody>
                  </table>
                </div>
              </div>
            </div>
          </span>
          <!-- add new user -->
          <span v-else>
            <h2 class="auth-title mb-1 mt-2">Inscription Nouvel Utilisateur</h2>
            <br>
            <div class="p-5" v-if="isLoading1">
              <fulfilling-bouncing-circle-spinner class="mx-auto"
                :animation-duration="2000" :size="60" :color="'#005C96'" />
            </div>
            <div v-else>
              <div class="alert alert-danger" v-if="errorMessage">
                {{ errorMessage }}
              </div>

              <form @submit="register">
                <div class="row col-6 mx-auto">
                  <!-- agence -->
                  <div class="col-12 form-group">
                    <label class="">Nom</label>
                    <input type="text" class="form-control"
                      v-model="newAdmin.lastname" placeholder="Nom" required />
                  </div>
                  <!-- client -->
                  <div class="col-12 form-group">
                    <label class="">Prénom(s)</label>
                    <input type="text" class="form-control"
                      v-model="newAdmin.firstname" placeholder="Nom" required />
                  </div>
                  <div class="col-12 form-group">
                    <label class="">Profession</label>
                    <input type="text" class="form-control"
                      v-model="newAdmin.profession"  placeholder="Profession" required/>
                  </div>
                  <div class="col-12 form-group">
                    <label class="">Email</label>
                    <input type="text" class="form-control"
                      v-model="newAdmin.email"  placeholder="Nom" required  />
                  </div>
                  <div class="col-12 form-group">
                    <label class="">Mot de passe</label>
                    <input type="password" class="form-control"
                      v-model="newAdmin.password" placeholder="Mot de passe" required />
                  </div>
                  <div class="col-12 form-group">
                    <label> Confirmer le Mot de passe</label>
                    <input type="password" class="form-control"
                      v-model="confpassword" placeholder="Confirmer mot de passe" required />
                  </div>
                  <div class="col-12 form-group">
                    <label>Rôle</label>
                    <v-select class="form-control-select" v-model="role"  required
                      :options="[{label: 'Admin', code: 'admin'}, {label: 'Reviewer', code: 'reviewer'},{label: 'Utilisateur', code: 'user'} ]">
                    </v-select>
                  </div>

                  <div class="col-sm-12" v-for="(file, i) in importFiles" :key="i">
                    <div class="form-group">
                      <label for="photo">{{i == 0 ? 'Photo de profil' : 'Fichier ' + (i+1)}}</label>
                      <div :class="'custom-file' + (imageData[i] ? ' filled' : '')">
                        <div
                          class="img-preview"
                          :style="'background-image: url(' + imageData[i] + ')'"
                        ></div>
                        <input
                          type="file"
                          class="custom-file-input"
                          :id="'customFile' + i"
                          :ref="'file' + i"
                          @change="handleFileUpload(i)"
                        />
                        <label
                          class="custom-file-label"
                          :for="'customFile' + i"
                        >{{ file.name || 'Choisir une photo'}}</label>
                      </div>
                  </div>
                  </div>
                </div>
                <div class="form-group col-sm-4 mx-auto mt-1">
                  <input type="submit" class="btn btn-light btn-block" value="Valider" />
                </div>
              </form>
              <div class="form-group text-center">
                <span class="text-manote" @click="creating = false;">Fermer !</span >
              </div>
            </div>
          </span>
        </div>
      </div>
    </div>
  </div>
</template>


<script>
const roles = {
  coordonator: "Cordonateur",
  manager: "Manageur",
  rse: "RSE",
  "rlm-antenne": "RLM Antenne",
  rlm: "RLM",
  admin: "Administrateur",
};
export default {
  name: "home",
  data() {
    return {
      admins: [],
      errorMessage: "",

      importFiles: [],
      imageData: [],
      fileNumber: 1,

      newAdmin: {
        email:'',
        password:'',
        firstname:'',
        lastname:'',
        profession:'',
      }, 
      role:"",
      creating: false,
      confpassword: "",

      searchtext: "",
      searchtype: "firstname",
      isLoading: false,
      isLoading1: false,
      curPage: 1,
      total: 0,
      perPage: 100,
      sort: {},
    };
  },
  mounted() {
    for (var i = 0; i < this.fileNumber; i++) {
      this.importFiles.push({});
      this.imageData.push("");
    }
    this.init(); 
  },
  filters: {
    getRoleLabel: function (value) {
      return roles[value];
    },
  },
  methods: {
    init(page, resetParams) {
      if (resetParams) {
        this.curPage = 1;
      }

      let query = {
        options: {
          role: "admin",
        },
        filter: {
          text: this.searchtext,
          type: this.searchtype.split("+"),
        },
        sort: this.sort,
        page: this.curPage - 1,
        perPage: this.perPage,
      };

      this.isLoading = true;
      this.$service.listAdmins(query, (err, data) => {
        this.isLoading = false;
        if (err) {
          console.log(err);
          return;
        }
        //console.log(data);
        this.total = data.total;
        this.admins = data.admins;
      });
    },
    showAdmin(id) {
      this.$router.push("/users/detail/" + id);
    },
    changeStatut(id,statut){
      let newStatut = !statut;
      this.errorMessage = "";
      this.$service.updateUser(id,{ active: newStatut},(err, data) => {
          if (err) {
            this.errorMessage = err.data && err.data.message;
            console.log("Error", err.data);
            return;
          }

          let datas = {
            admin : age.getItem("adminId"),

            message: 'change status admin : ' + id,
            date: new Date(),
            position : this.center,
          }
          this.$service.create("historiques", datas, (err, data) => {
            if (err) {
              this.errorMessage = err.data && err.data.message;
              return;
            }
            this.$swal.fire("Statut changé !!!", "", "success").then(() => {
              this.init();
            }); 
          });
        }
      );
    },
    register(e) {
      e.preventDefault();
      this.errorMessage = ""; this.isLoading1 = true
      
      if (this.newAdmin.password == this.confpassword) { 
        this.newAdmin.role = this.role.code;
        let formData = new FormData();
        formData.append("fileprop", "pictures");
        formData.append("filenumber", this.fileNumber);
        formData.append("objectdata", JSON.stringify(this.newAdmin));

        for (var i = 0; i < this.fileNumber; i++) {
          if (this.importFiles[i].name) {
            formData.append("filedata" + i, this.importFiles[i]);
          }
        } 
        this.$service.registerAdminWithFile(formData, (err, data) => {
          this.isLoading1 = true;
          if (err) {this.errorMessage = err.data && err.data.message;console.log("Error", err.data);return;}
          this.$swal.fire("Enrégistrement effectué !", "", "success").then(() => {
            //this.$router.push({ path: "/users/admins" }); 
            this.newAdmin = {
              email:'',
              password:'',
              firstname:'',
              lastname:'',
              profession:'',
            }, 
            this.creating = false;
            this.init();
          });
        });
      } else {
        this.errorMessage = "Confirmation mot de passe échouée.";
      }
    },
    removeAdmin(id) {
      this.$swal
        .fire({
          title: "Voulez vous vraiment supprimer?",
          text: "Vous ne pouvez recuperer ses données!",
          icon: "warning",
          showCancelButton: true,
          cancelButtonColor: "#3085d6",
          confirmButtonColor: "#d33",
          confirmButtonText: "Oui, supprimer!",
        })
        .then((result) => {
          if (result.value) {
            this.$service.removeAdmin(id, (err, data) => {
              if (err) {
                this.errorMessage = err.data && err.data.message;
                console.log("Error", err.data);
                return;
              }

              this.$swal
                .fire(
                  "Suppression réussie",
                  "La suppression s'est effectuée avec succès",
                  "success"
                )
                .then(() => {
                  //this.init();
                });
            });
          }
        });
    },
    handleFileUpload(index) {
      console.log(this.$refs["file" + index][0]);
      this.importFiles[index] = this.$refs["file" + index][0].files[0];
      if (this.importFiles[index]) {
        const reader = new FileReader();
        reader.onload = (e) => {
          this.imageData[index] = e.target.result;
          this.$forceUpdate();
        };
        reader.readAsDataURL(this.importFiles[index]);
      }
      this.$forceUpdate();
    },
  },
};
</script>
